
ChiliProject - Bug # 442: Issue atom feed shows "issue creation" journal, didn't before

Status: Closed Priority: Normal
Author: Felix Schäfer Category: Journals / History
Created: 2011-06-02 Assignee: Eric Davis
Updated: 2011-06-10 Due date:
Remote issue URL:
Affected version: unstable
Description: The atom feed for an individual issue @/issues/:id.atom@ shows the journal for the issue creation, this wasn't 

present in previous versions. Showing that journal doesn't make much sense as it doesn't give any significant 
information, so I think it can be left out. Alternatively, I don't feel the atom feed is complete if it doesn't include 
the initial state but just the changes, should we add an initial entry reflecting the initial state of the issue?

Associated revisions
2011-06-10 08:21 pm - Eric Davis
[#442] Handle nil changes in Atom feed

History
2011-06-03 03:32 pm - Eric Davis
I want to look into this initial journal. It seems to be causing some other problems and I'm not sure why we need it.

2011-06-03 04:02 pm - Felix Schäfer
Eric Davis wrote:
> I want to look into this initial journal. It seems to be causing some other problems and I'm not sure why we need it.

They might be causing some problems, but getting rid of them is not the right solution. The activity for example is now only one request to the 
@journals@ table with the correct types, before it was to at least as many tables as types you wanted to see in the activity. If you remove the initial 
journal, you'd have to query every object for its creation date in addition to just the @journals@ table. Furthermore, we could now have something like 
"created on" and "deleted on" entries in the journals so that deleted issues/whatever still leave a trace.

Anyway, what I'd like to have discussed here is if we just remove the initial entry from the ATOM feed for now to keep compatibility, or if we remove the 
initial entry and replace it with an entry of the full initial issue. I think having the full initial state of the issue as the first entry is "more right", but would 
need more work, so I'd say just filter the initial journal for now and rework the ATOM feed later.

2011-06-03 06:23 pm - Eric Davis
- Assignee set to Eric Davis

Felix SchÃ¤fer wrote:
> They might be causing some problems, but getting rid of them is not the right solution. The activity for example is now only one request to the 
@journals@ table with the correct types...

Ah so the initial journal is used for the "created Issue" activity. That makes sense then. I just couldn't find the code (or comments) that defined that.

> Anyway, what I'd like to have discussed here is if we just remove the initial entry from the ATOM feed for now to keep compatibility, or if we remove 
the initial entry and replace it with an entry of the full initial issue. I think having the full initial state of the issue as the first entry is "more right", but would 
need more work, so I'd say just filter the initial journal for now and rework the ATOM feed later.

I think you're right about the full changes. I think of the atom feed as a list of the changes to an issue, which could be either way (changes after creation 
or all changes). But if we track the original state of the object at creation, then we would be able to query/diff/compare it easier. Let me see if I can 
prototype this.

(At the very least I'll see about changing the ATOM feed)
2011-06-03 06:36 pm - Eric Davis
- File initial-journal-feed.png added

- File example_feed.xml added

I really like the feed with the full details. I faked it out by changing the initial creation journal to show the state change of @nil@ => @value@. Examples 
attached:

!initial-journal-feed.png!

2011-06-03 08:07 pm - Eric Davis
- Target version set to 2.0.0

- Status changed from Open to Ready for review

Posted my code and research on initial journal tracking to #445. If that change is merged in then this issue will not be needed (the initial journal would 
list the "creation" attributes).

2011-06-10 06:23 pm - Eric Davis
- Status changed from Ready for review to Closed

Now that #445 has been added the Atom feed will show the initial state of the issue. I added a small bugfix for nil changes that was trying to get 
converted to a string in commit:1e68bed.

Files
initial-journal-feed.png 34.9 kB 2011-06-03 Eric Davis
example_feed.xml 2.3 kB 2011-06-03 Eric Davis
